## TpHandleChannelsContext

TpHandleChannelsContext — context of a Handler.HandleChannels() call

## Functions

void | tp_handle_channels_context_accept ()
void | tp_handle_channels_context_delay ()
void | tp_handle_channels_context_fail ()
const GHashTable * | tp_handle_channels_context_get_handler_info ()
GList * | tp_handle_channels_context_get_requests ()

## Properties

TpAccount * | account | Read / Write / Construct Only
GPtrArray * | channels | Read / Write / Construct Only
TpConnection * | connection | Read / Write / Construct Only
gpointer | dbus-context | Write / Construct Only
GHashTable_gchararray+GValue_* | handler-info | Read / Write / Construct Only
GPtrArray * | requests-satisfied | Read / Write / Construct Only
gint64 | user-action-time | Read / Write / Construct Only

## Signals

void | done | Has Details

## Types and Values

| TpHandleChannelsContext

## Object Hierarchy

        GObject
        ╰── TpHandleChannelsContext

## Includes

    #include <telepathy-glib/telepathy-glib.h>

## Description

Object used to represent the context of a Handler.HandleChannels() D-Bus call on a TpBaseClient.

## Functions

### tp_handle_channels_context_accept ()

    void
    tp_handle_channels_context_accept (TpHandleChannelsContext *self);

Called by TpBaseClientClassAddDispatchOperationImpl when it's done so the D-Bus method can return.

The caller is responsible for closing channels with `tp_cli_channel_call_close()` when it has finished handling them.

#### Parameters

self | a TpHandleChannelsContext |

Since: 0.11.6

### tp_handle_channels_context_delay ()

    void
    tp_handle_channels_context_delay (TpHandleChannelsContext *self);

Called by TpBaseClientClassAddDispatchOperationImpl to indicate that it implements the method in an async way. The caller must take a reference to the TpHandleChannelsContext before calling this function, and is responsible for calling either `tp_handle_channels_context_accept()` or `tp_handle_channels_context_fail()` later.

#### Parameters

self | a TpHandleChannelsContext |

Since: 0.11.6

### tp_handle_channels_context_fail ()

    void
    tp_handle_channels_context_fail (TpHandleChannelsContext *self,
                                     const GError *error);

Called by TpBaseClientClassAddDispatchOperationImpl to raise a D-Bus error.

#### Parameters

self | a TpHandleChannelsContext |
error | the error to return from the method |

Since: 0.11.6

### tp_handle_channels_context_get_handler_info ()

    const GHashTable *
    tp_handle_channels_context_get_handler_info
                                   (TpHandleChannelsContext *self);

Return any extra information that accompanied this request to handle channels (the Handler_Info argument from the HandleChannels D-Bus method). Well-known keys for this map will be defined by the Telepathy D-Bus Interface Specification; at the time of writing, none have been defined.

The returned hash table is only valid for as long as `self` is.

#### Parameters

self | a channel-handling context |

#### Returns

extensible extra handler information, in a form suitable for use with `tp_asv_get_string()` etc.

[transfer none][element-type utf8 GObject.Value]

Since: 0.11.14

### tp_handle_channels_context_get_requests ()

    GList *
    tp_handle_channels_context_get_requests
                                   (TpHandleChannelsContext *self);

Return a list of the TpChannelRequest which have been satisfied by the channels associated with self.

#### Parameters

self | a channel-handling context |

#### Returns

a newly allocated GList of reffed TpChannelRequest.

[transfer full][element-type TelepathyGLib.ChannelRequest]

Since: 0.13.14

## Types and Values

### TpHandleChannelsContext

    typedef struct _TpHandleChannelsContext TpHandleChannelsContext;

Data structure representing the context of a Handler.HandleChannels() call.

Since: 0.11.6

## Property Details

### The `“account”` property

      “account”                  TpAccount *

A TpAccount object representing the Account of the DispatchOperation that has been passed to HandleChannels. Read-only except during construction.

This property can't be `NULL`.

Flags: Read / Write / Construct Only

Since: 0.11.6

### The `“channels”` property

      “channels”                 GPtrArray *

A GPtrArray containing TpChannel objects representing the channels that have been passed to HandleChannels. Read-only except during construction.

This property can't be `NULL`.

Flags: Read / Write / Construct Only

Since: 0.11.6

### The `“connection”` property

      “connection”               TpConnection *

A TpConnection object representing the Connection of the DispatchOperation that has been passed to HandleChannels. Read-only except during construction.

This property can't be `NULL`.

Flags: Read / Write / Construct Only

Since: 0.11.6

### The `“dbus-context”` property

      “dbus-context”             gpointer

The DBusGMethodInvocation representing the D-Bus context of the HandleChannels call. Can only be written during construction.

[skip]

Flags: Write / Construct Only

Since: 0.11.6

### The `“handler-info”` property

      “handler-info”             GHashTable_gchararray+GValue_*

A GHashTable where the keys are string and values are GValue instances. It represents the Handler_info hash table that has been passed to HandleChannels.

This property can't be `NULL`.

Flags: Read / Write / Construct Only

Since: 0.11.6

### The `“requests-satisfied”` property

      “requests-satisfied”       GPtrArray *

A GPtrArray containing TpChannelRequest objects representing the requests that have been passed to HandleChannels. Read-only except during construction.

This property can't be `NULL`.

Flags: Read / Write / Construct Only

Since: 0.11.6

### The `“user-action-time”` property

      “user-action-time”         gint64

The time at which user action occurred, or one of the special values `TP_USER_ACTION_TIME_NOT_USER_ACTION` or `TP_USER_ACTION_TIME_CURRENT_TIME` (see “user-action-time” for details)

Read-only except during construction.

Flags: Read / Write / Construct Only

Allowed values: >= 0

Default value: 0

Since: 0.11.6

## Signal Details

### The `“done”` signal

    void
    user_function (TpHandleChannelsContext *self,
                   gpointer                 user_data)

Emitted when tp_handle_channels_context_accept has been called on `self` .

#### Parameters

self | a TpHandleChannelsContext |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

Since: 0.11.6